components/ejabberd/xmpp-ejabberd
changeset 353 d9644516b4a8
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/components/ejabberd/xmpp-ejabberd	Wed Jun 29 15:33:37 2011 -0700
@@ -0,0 +1,66 @@
+#! /usr/bin/ksh93
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+
+#
+# Copyright (c) 2009, 2011, Oracle and/or its affiliates. All rights reserved.
+#
+
+# wait_until <time> <condition>
+# 
+#  Check if condition is true. If yes, return 0 immediately. If not, 
+#  keep checking it until either the condition becomes true or the
+#  specified time have passed. Return 1 in later case.
+#
+wait_until () {
+	total=$1
+	cond="$2"
+
+	i=0
+	while (( i < total )); do
+		eval $cond > /dev/null
+		(( $? == 0 )) && return 0
+		sleep 1
+		i=$(( i + 1 ))
+	done
+	return 1
+}
+
+source /lib/svc/share/smf_include.sh
+
+typeset -r EJABBERDCTL=/usr/sbin/ejabberdctl
+
+case "$1" in
+start)
+        ${EJABBERDCTL} start 2>&1
+	wait_until 60 "${EJABBERDCTL} status | grep 'is running'"
+        ;;
+stop)
+        ${EJABBERDCTL} stop 2>&1
+	wait_until 60 "${EJABBERDCTL} status | grep 'nodedown'"
+        ;;
+*)
+        print "Usage: $0 {start|stop}"
+        exit 1
+        ;;
+esac
+
+# not reached